% **************************************************************************** %
% Author: Lambert Theisen
% => lambert.theisen@rwth-aachen.de
% => lambert.theisen@gmail.com
% Created: January 2019
% **************************************************************************** %



% **************************************************************************** %
% KOMA SCRIPT CUSTOMIZATION
% **************************************************************************** %

  \newcommand{\bgColorSection}{darkblue}
  \newcommand{\bgColorSubsection}{lightblue}
  \newcommand{\bgColorSubsubsection}{llightblue}
  \newcommand{\bgColorParagraph}{lightgray}

  \newcommand{\textColorSection}{white}
  \newcommand{\textColorSubsection}{white}
  \newcommand{\textColorSubsubsection}{white}
  \newcommand{\textColorParagraph}{black}

  % Section
  \RedeclareSectionCommand[
    beforeskip=4pt, % Remove spaces before
    afterskip=4pt   % Remove spaces after
  ]{section}

  % Subsection
  \RedeclareSectionCommand[
    beforeskip=4pt, % Remove spaces before
    afterskip=4pt   % Remove spaces after
  ]{subsection}

  % Subsubsection
  \RedeclareSectionCommand[
    beforeskip=4pt, % Remove spaces before
    afterskip=4pt   % Remove spaces after
  ]{subsubsection}

  % Paragraph
  \RedeclareSectionCommand[
    beforeskip=4pt, % Remove spaces before
  ]{paragraph}

  % Color boxed section titles
  \addtokomafont{section}{\mySection}
  \newcommand{\mySection}[1]{%
  \setlength{\fboxsep}{0cm}%
  \colorbox{\bgColorSection}{%
    \begin{minipage}{\linewidth}%
      \vspace*{3pt}%
        \hspace*{0pt}
        \normalsize
        \color{\textColorSection}
        \MakeUppercase{#1}
      \vspace*{3pt}%
    \end{minipage}%
  }}

  % Color boxed subsection titles
  \addtokomafont{subsection}{\mySubsection}
  \newcommand{\mySubsection}[1]{%
  \setlength{\fboxsep}{0cm}%
  \colorbox{\bgColorSubsection}{%
    \begin{minipage}{\linewidth}%
      \vspace*{3pt}%
        \small
        \color{\textColorSubsection}
        \MakeUppercase{#1}
      \vspace*{3pt}%
    \end{minipage}%
  }}

  % Color boxed subsubsection titles
  \addtokomafont{subsubsection}{\mySubsubsection}
  \newcommand{\mySubsubsection}[1]{%
  \setlength{\fboxsep}{0cm}%
  \colorbox{\bgColorSubsubsection}{%
    \begin{minipage}{\linewidth}%
      \vspace*{3pt}%
        \small
        \color{\textColorSubsubsection}
        #1
      \vspace*{3pt}%
    \end{minipage}%
  }}

  % Color boxed paragraph titles
  \addtokomafont{paragraph}{\myParagraph}
  \newcommand{\myParagraph}[1]{%
  \setlength{\fboxsep}{0cm}%
  \colorbox{\bgColorParagraph}{%
    \begin{minipage}{\linewidth}%
      \color{\textColorParagraph}
      #1
    \end{minipage}%
  }}
% **************************************************************************** %